// UpdatingGUI.java
// Race Conditions when updating Swing Components.
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class UpdatingGUI extends JFrame {
  private JTextField infoField;

  public UpdatingGUI() {
    Container cp = getContentPane();
    infoField = new JTextField("One");
    cp.add(infoField, BorderLayout.NORTH);

    addWindowListener(new WindowAdapter() {
      public void windowOpened(WindowEvent e) { // Executed in the event dispatch thread
        try { // Intentional initialization overhead
          Thread.sleep(2000);
        } catch (InterruptedException ex) {
          System.err.println(ex);
        }
        infoField.setText(infoField.getText() + " Two");
      }
    });

    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    pack();
    setVisible(true);
  }

  public static void main (String[] args) {
    UpdatingGUI frame = new UpdatingGUI();
    frame.infoField.setText(frame.infoField.getText() + " Three"); // Executed in the main thread
    System.out.println("Four");
  }
}